// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import java.io.IOException;
import java.util.ResourceBundle;
import java.util.List;
import javax.swing.JOptionPane;


public class ScanListener implements ActionListener{

    private MainWindow window=null;

    public ScanListener(MainWindow mainwin){
        window=mainwin;
    }

    public void actionPerformed(ActionEvent evt){
        CommClient commcli=window.getCommClient();
        ResourceBundle bundle=window.getBundle();
        String msgerr=null, err=bundle.getString("ERR");
        List<BSSInfo> scan=null;
        boolean msgsend=false;
        byte[] response=null;

        
        try{
            commcli.sendMsg(new byte[]{Msg.SCAN});
            msgsend=true;
            response=commcli.getResponse();
            if(response[1]==Msg.NONE){
                window.reportUser(MainWindow.TYPEINFO,
                                  bundle.getString("INF_NOBSS"));
            }else if(response[1]==Msg.OK){
                scan=MsgOptParser.parseScanInfo(response, 2, response.length-2);
                if(scan!=null && scan.size()>0){
                    window.setScanInfo(scan);
                    window.reportUser(MainWindow.TYPEINFO,
                                      bundle.getString("INF_SCAN")+
                                      ": "+scan.size());
                }else
                    window.reportUser(MainWindow.TYPEINFO,
                                      bundle.getString("INF_NOBSS"));

            }else if(response[1]==Msg.SERVER_ERROR){
                throw new IllegalStateException("Error code: "+response[2]);
            }
            
        }catch(IOException io){
            if(msgsend)
                msgerr=bundle.getString("ERR_NORESPONSE");
            else
                msgerr=bundle.getString("ERR_BREAKCONNECT");

        }catch(IllegalStateException ile){
            ile.printStackTrace(System.err);
            msgerr=bundle.getString("ERR_SERVER");
        }

        if(msgerr!=null)
            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);
    }   
}
